/* Sa se determine costul minim al unui drum
    de la pozitia(ip, jp) la (is, js)
    intr-o matrice cu obstacole
*/
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
#include <iomanip>
using namespace std;

ifstream fin("lee.in");
ofstream fout("lee.out");

using PI = pair<int, int>;
using VI = vector<int>;
using VVI = vector<VI>;

const int di[] = {-1, 0, 1, 0},
          dj[] = {0, 1, 0, -1},
          Inf = 0x3f3f3f3f;

int n, m, ip, jp, is, js;
VVI c;   // c[i][j] = costul minim
VVI L;   // cu 0 si 1 (codifica labirintul)

void ReadData();
bool Ok(int i, int j);
void Lee(int ip, int jp, int is, int js, VVI& c);
void WriteSol();

int main()
{
    ReadData();
    Lee(ip, jp, is, js, c);

    WriteSol();

    fin.close();
    fout.close();
}

void Lee(int ip, int jp, int is, int js, VVI& c)
{
    queue<PI> Q;  // declar o coada vida
    c[ip][jp] = 0;
    Q.push({ip, jp});
    int i, j, iv, jv;
    while (!Q.empty())
    {
        i = Q.front().first;
        j = Q.front().second;
        Q.pop();

        for (int d = 0; d < 4; ++d)
        {
            iv = i + di[d];
            jv = j + dj[d];
            if (Ok(iv, jv) && c[iv][jv] > c[i][j] + 1)
            {
                c[iv][jv] = c[i][j] + 1;
                Q.push({iv, jv});
            }
        }
    }
}

void WriteSol()
{
    fout << c[is][js] << '\n';

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
            if (L[i][j] == 1)
                fout << " []";
            else
                if (c[i][j] == Inf)
                    fout << " oo";
                else
                    fout << setw(3) << c[i][j];
        fout << '\n';
    }
}

bool Ok(int i, int j)
{
    if (i < 0 || i >= n || j < 0 || j >= m) // in afara matricei
        return false;
    if (L[i][j] == 1)  // obstacol
        return false;
    return true;
}

void ReadData()
{
    fin >> n >> m;

    L = vector<vector<int>>(n, VI(m));
    c = VVI(n, VI(m, Inf));
    fin >> ip >> jp >> is >> js;
    ip--, jp--, is--, js--;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            fin >> L[i][j];
}
