/* Sa se determine costul minim al unui drum
    de la pozitia(ip, jp) la (is, js)
    intr-o matrice cu valori
*/
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <tuple>
using namespace std;

ifstream fin("lee.in");
ofstream fout("lee.out");

using PI = pair<int, int>;
using VI = vector<int>;
using VVI = vector<VI>;

const int di[] = {-1, 0, 1, 0},
          dj[] = {0, 1, 0, -1},
          Inf = 0x3f3f3f3f;

int n, m, ip, jp, is, js;
VVI c;   // c[i][j] = costul minim
VVI L;   // cu 0 si 1 (codifica labirintul)

void ReadData();
bool Ok(int i, int j);
void Lee(int ip, int jp, int is, int js, VVI& c);
void WriteSol();

int main()
{
    ReadData();
    Lee(ip, jp, is, js, c);
    WriteSol();

    fin.close();
    fout.close();
}

#define iv (i + di[d])
#define jv (j + dj[d])

void Lee(int ip, int jp, int is, int js, VVI& c)
{
    queue<PI> Q;  // declar o coada vida
    c[ip][jp] = L[ip][jp];
    Q.push({ip, jp});
    int i, j;
    while (!Q.empty())
    {
        tie(i, j) = Q.front();
        Q.pop();

        for (int d = 0; d < 4; ++d)
            if (Ok(iv, jv) && c[iv][jv] > c[i][j] + L[iv][jv])
            {
                c[iv][jv] = c[i][j] + L[iv][jv];
                Q.push({iv, jv});
            }
    }
}

void WriteSol()
{
    fout << c[is][js] << '\n';

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
            if (L[i][j] == 1)
                fout << " []";
            else
                if (c[i][j] == Inf)
                    fout << " oo";
                else
                    fout << setw(3) << c[i][j];
        fout << '\n';
    }
}

bool Ok(int i, int j)
{
    if (i < 0 || i >= n || j < 0 || j >= m) // in afara matricei
        return false;

    return true;
}

void ReadData()
{
    fin >> n >> m;

    L = VVI(n, VI(m));
    c = VVI(n, VI(m, Inf));
    fin >> ip >> jp >> is >> js;
    ip--, jp--, is--, js--;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            fin >> L[i][j];
}
