#include <fstream>
#include <iomanip>
using namespace std;

ifstream is("labirint.in");
ofstream os("labirint.out");
int m, n;
char L[100][100];
int c[100][100]; // c[i][j] - lung minima a drumului
                 // de la (iP, jP) la (i, j)
int iP, jP, iS, jS;
const int di[] = { -1, 0, 1, 0 };
const int dj[] = { 0, 1, 0, -1 };

void Read();
bool OK(int i, int j);
void Lee();
void Write();

int main()
{
    Read();
    Lee();
    Write();
    is.close();
    os.close();
    return 0;
}

void Read()
{
    is >> m >> n;
    is >> iP >>jP >> iS >> jS;
    for (int i = 1; i <= m; ++i )
        for (int j = 1; j <= n; ++j )
            is >> L[i][j];
}

bool OK(int i, int j)
{
    if ( L[i][j] == '#' ) // obstacol
        return false;
    if ( i < 1 || i > m || j < 1 || j > n ) // in afara labirintului
        return false;
    if ( c[i][j] ) // am mai trecut pe aici
        return false;
    return true;
}

void Lee()
{
    bool modif = true;
    int iv, jv;
    c[iP][jP] = 1;
    int pas = 1;
    while ( modif )
    {
        modif = false;
        for ( int i = 1; i <= m; ++i )
            for ( int j = 1; j <= n; ++j )
                if ( c[i][j] == pas )
                {
                    for ( int d = 0; d < 4; ++d )
                    {
                        iv = i + di[d];
                        jv = j + dj[d];
                        if ( OK(iv, jv) )
                        {
                            c[iv][jv] = pas + 1;
                            modif = true;
                            if ( iv == iS && jv == jS )
                                return;
                        }
                    }
                }
        pas++;
    }
}

void Write()
{
    os << c[iS][jS] << '\n';
    for ( int i = 1; i <= m; ++i )
    {
        for ( int j = 1; j <= n; ++j )
            if ( L[i][j] == '#' )
                os << setw(3) << "[]";
            else
                if ( c[i][j] != 0 )
                    os << setw(3) << c[i][j];
                else
                    os << "   ";
        os << '\n';
    }
}
